/*
 * GUI.c
 *
 *  Created on: 202369
 *      Author: Liminnan
 */

#include "debug.h"
#include "LCD.h"
#include "GUI.h"
#include "font.h"
#include <stdarg.h>
#include <stdlib.h>
#include <math.h>
#include <spi.h>
extern uint8_t lcd_buffer[BUFFER_SIZE]; // 洢Ҫ䵽LCDĻ
void Gui_Printf(u16 x, u16 y, void *Font, u16 fc, u16 bc, const char *format, ...)
{
    // ַڴ洢ʽַ
    char buffer[256];

    // ʹÿɱбĸʽַ
    va_list args;
    va_start(args, format);

    // ʽַд뻺
    vsprintf(buffer, format, args);

    // ɱбĴ
    va_end(args);

    // ѡöӦĻƺ
    if (Font == Gui_DrawFont_GBK16)
    {
        Gui_DrawFont_GBK16(x, y, fc, bc, (u8*)buffer);
    }
    else if (Font == Gui_DrawFont_GBK24)
    {
        Gui_DrawFont_GBK24(x, y, fc, bc, (u8*)buffer);
    }
    // ԸҪӸѡ
}
/*FC:GUI_ChangeBK_Test;
 *ˢ
 * */
void Gui_ChangeBK_Test(void){
    Lcd_Clear(YELLOW);
 for (u8 i=0; i <64; i++)
   {

     Gui_Printf(0, 0, Gui_DrawFont_GBK16, YELLOW, BLUE,"xxxxxXXXXX %d",i);
   }
   Lcd_Clear(BLUE);
 for (u8 i=0; i <64; i++)
   {

     Gui_Printf(0, 0, Gui_DrawFont_GBK16,  BLUE,RED, "xxxxxXXXXX %d",i);
   }
 Lcd_Clear(RED);
 for (u8 i=0; i <64; i++)
   {

     Gui_Printf(0, 0, Gui_DrawFont_GBK16,  RED, OLIVE, "xxxxxXXXXX %d",i);
   }
 Lcd_Clear(OLIVE);
 for (u8 i=0; i <64; i++)
   {

     Gui_Printf(0, 0, Gui_DrawFont_GBK16,  OLIVE,PINK,  "xxxxxXXXXX %d",i);
   }
 Lcd_Clear(PINK);
 for (u8 i=0; i <64; i++)
   {

     Gui_Printf(0, 0, Gui_DrawFont_GBK16,  PINK,WHITE, "xxxxxXXXXX %d",i);
   }
}
//ILI93xxΪGBRʽдʱΪRGBʽ
//ͨúת
//c:GBRʽɫֵ
//ֵRGBʽɫֵ
u16 LCD_BGR2RGB(u16 c)
{
  u16  r,g,b,rgb;
  b=(c>>0)&0x1f;
  g=(c>>5)&0x3f;
  r=(c>>11)&0x1f;
  rgb=(b<<11)+(g<<5)+(r<<0);
  return(rgb);

}
/*Gui_Ring
 *ܣһԲ
 *ڲu16 X, u16 Y, u16 innerRadius, u16 outerRadius, u16 fc, u16 bc, u8 lineWidth
 *ڲԲģx,y뾶Rɫcolor߿lineWidth
 * Waring㷨ڻƴ뾶ͽϿ߿ʱܻؼ϶򲻹ԡ
 */
void Gui_Circle(u16 X, u16 Y, u16 R, u16 color, u8 lineWidth)
{
    if(R>64)return;
    int i, j;
    for (i = R - lineWidth; i <= R; i++) {
           for (j = 0; j < 360; j++) {
               double angle = j * 3.14159 / 180.0;
               int x = X + i * cos(angle);
               int y = Y + i * sin(angle);
               Gui_DrawPoint(x, y, color);
           }
       }
}
/*Gui_Ring
 *ܣһԲ
 *ڲu16 X, u16 Y, u16 innerRadius, u16 outerRadius, u16 fc, u16 bc, u8 lineWidth
 *ڲԲģx,yڰ뾶inR뾶outR,ԲɫfcԲɫ(bc)߿lineWidth
 * Waring㷨ڻƴ뾶ͽϿ߿ʱܻؼ϶򲻹ԡ
 * **********************/
void Gui_Ring(u16 X, u16 Y, u16 innerRadius, u16 outerRadius, u16 fc, u16 bc, u8 lineWidth)
{
    int i, j;

    for (i = outerRadius - lineWidth; i <= outerRadius; i++) {
        for (j = 0; j < 360; j++) {
            double angle = j * 3.14159 / 180.0;
            int x = X + i * cos(angle);
            int y = Y + i * sin(angle);
            Gui_DrawPoint(x, y, fc);
        }
    }

    for (i = innerRadius + 1; i <= innerRadius + lineWidth; i++) {
        for (j = 0; j < 360; j++) {
            double angle = j * 3.14159 / 180.0;
            int x = X + i * cos(angle);
            int y = Y + i * sin(angle);
            Gui_DrawPoint(x, y, bc);
        }
    }
}
void Gui_DrawLine(u16 x0, u16 y0, u16 x1, u16 y1, u16 Color, u8 lineWidth)
{
    int dx = abs(x1 - x0);
    int dy = abs(y1 - y0);
    int sx = (x0 < x1) ? 1 : -1;
    int sy = (y0 < y1) ? 1 : -1;
    int err = dx - dy;

    while (1) {
        // ƶص㣬ʵ߿
        for (int i = -lineWidth/2; i <= lineWidth/2; i++) {
            Gui_DrawPoint(x0 + i, y0, Color);  // ƺ
            Gui_DrawPoint(x0, y0 + i, Color);  // 
        }

        if (x0 == x1 && y0 == y1) {
            break;
        }
        int e2 = 2 * err;
        if (e2 > -dy) {
            err -= dy;
            x0 += sx;
        }
        if (e2 < dx) {
            err += dx;
            y0 += sy;
        }
    }
}



void Gui_box(u16 x, u16 y, u16 w, u16 h,u16 bc,u8 lineWidth)
{
    Gui_DrawLine(x,y,x+w,y,bc,lineWidth);
    Gui_DrawLine(x+w-1,y+1,x+w-1,y+1+h,bc,lineWidth);
    Gui_DrawLine(x,y+h,x+w,y+h,bc,lineWidth);
    Gui_DrawLine(x,y,x,y+h,bc,lineWidth);
}

/**************************************************************************************
: Ļʾһ͹İť
    : u16 x1,y1,x2,y2 ťϽǺ½
    : 
**************************************************************************************/
void DisplayButtonDown(u16 x1,u16 y1,u16 x2,u16 y2)
{
    Gui_DrawLine(x1,  y1,  x2,y1, GRAY2, 2);  //H
    Gui_DrawLine(x1+1,y1+1,x2,y1+1,GRAY1,2);  //H
    Gui_DrawLine(x1,  y1,  x1,y2,  GRAY2,2);  //V
    Gui_DrawLine(x1+1,y1+1,x1+1,y2,GRAY1,2);  //V
    Gui_DrawLine(x1,  y2,  x2,y2,  WHITE,2);  //H
    Gui_DrawLine(x2,  y1,  x2,y2,  WHITE,2);  //V
}
/**************************************************************************************
: Ļʾһµİť
    : u16 x1,y1,x2,y2 ťϽǺ½
    : 
**************************************************************************************/
void DisplayButtonUp(u16 x1,u16 y1,u16 x2,u16 y2)
{
    Gui_DrawLine(x1,  y1,  x2,y1, WHITE,2); //H
    Gui_DrawLine(x1,  y1,  x1,y2, WHITE,2); //V

    Gui_DrawLine(x1+1,y2-1,x2,y2-1, GRAY1,2);  //H
    Gui_DrawLine(x1,  y2,  x2,y2, GRAY2,2);  //H
    Gui_DrawLine(x2-1,y1+1,x2-1,y2, GRAY1,2);  //V
    Gui_DrawLine(x2  ,y1  ,x2,y2, GRAY2,2); //V
}
/******************************************************************************
      ˵ʾ12x12
      ݣx,yʾ
                *s Ҫʾĺ
                fc ֵɫ
                bc ֵıɫ
                sizey ֺ
                mode:  0ǵģʽ  1ģʽ
      ֵ  
******************************************************************************/
void Gui_DrawFont_GBK12(u16 x, u16 y, u16 fc, u16 bc, u8 *s)
{
    unsigned char i,j;
      unsigned short k,x0;
      x0=x;

      while(*s)
      {
          if((*s) < 128)
          {
              k=*s;
              if (k==13)
              {
                  x=x0;
                  y+=16;
              }
              else
              {
                  if (k>32) k-=32; else k=0;

                  for(i=0;i<16;i++)
                  for(j=0;j<8;j++)
                      {
                          if(asc16[k*16+i]&(0x80>>j)) Gui_DrawPoint(x+j,y+i,fc);
                          else
                          {
                              if (fc!=bc) Gui_DrawPoint(x+j,y+i,bc);
                          }
                      }
                  x+=8;
              }
              s++;
          }

          else
          {
              for (k=0;k<hz12_num;k++)
              {
                if ((hz12[k].Index[0]==*(s))&&(hz12[k].Index[1]==*(s+1)))
                {
                      for(i=0;i<12;i++)
                      {
                          for(j=0;j<8;j++)
                              {
                                  if(hz12[k].Msk[i]&(0x80>>j))  Gui_DrawPoint(x+j,y+i,fc);
                                  else {
                                      if (fc!=bc) Gui_DrawPoint(x+j,y+i,bc);
                                  }
                              }
                          for(j=0;j<8;j++)
                              {
                                  if(hz12[k].Msk[i+1]&(0x80>>j))    Gui_DrawPoint(x+j+8,y+i,fc);
                                  else
                                  {
                                      if (fc!=bc) Gui_DrawPoint(x+j+8,y+i,bc);
                                  }
                              }
                      }
                  }
                }
              s+=2;x+=12;
          }

      }
}
void Gui_DrawFont_GBK16(u16 x, u16 y, u16 fc, u16 bc, u8 *s)
{
    unsigned char i,j;
    unsigned short k,x0;
    x0=x;

    while(*s)
    {
        if((*s) < 128)
        {
            k=*s;
            if (k==13)
            {
                x=x0;
                y+=16;
            }
            else
            {
                if (k>32) k-=32; else k=0;

                for(i=0;i<16;i++)
                for(j=0;j<8;j++)
                    {
                        if(asc16[k*16+i]&(0x80>>j)) Gui_DrawPoint(x+j,y+i,fc);
                        else
                        {
                            if (fc!=bc) Gui_DrawPoint(x+j,y+i,bc);
                        }
                    }
                x+=8;
            }
            s++;
        }

        else
        {
            for (k=0;k<hz16_num;k++)
            {
              if ((hz16[k].Index[0]==*(s))&&(hz16[k].Index[1]==*(s+1)))
              {
                    for(i=0;i<16;i++)
                    {
                        for(j=0;j<8;j++)
                            {
                                if(hz16[k].Msk[i*2]&(0x80>>j))  Gui_DrawPoint(x+j,y+i,fc);
                                else {
                                    if (fc!=bc) Gui_DrawPoint(x+j,y+i,bc);
                                }
                            }
                        for(j=0;j<8;j++)
                            {
                                if(hz16[k].Msk[i*2+1]&(0x80>>j))    Gui_DrawPoint(x+j+8,y+i,fc);
                                else
                                {
                                    if (fc!=bc) Gui_DrawPoint(x+j+8,y+i,bc);
                                }
                            }
                    }
                }
              }
            s+=2;x+=16;
        }

    }
}

void Gui_DrawFont_GBK24(u16 x, u16 y, u16 fc, u16 bc, u8 *s)
{
    unsigned char i,j;
    volatile unsigned short k;

    while(*s)
    {
        if( *s < 0x80 )
        {
            k=*s;
            if (k>32) k-=32; else k=0;

            for(i=0;i<16;i++)
            for(j=0;j<8;j++)
                {
                    if(asc16[k*16+i]&(0x80>>j))
                    Gui_DrawPoint(x+j,y+i,fc);
                    else
                    {
                        if (fc!=bc) Gui_DrawPoint(x+j,y+i,bc);
                    }
                }
            s++;x+=8;
        }
        else
        {

            for (;k<hz24_num;k++)
            {
              if ((hz24[k].Index[0]==*(s))&&(hz24[k].Index[1]==*(s+1)))
              {
                    for(i=0;i<24;i++)
                    {
                        for(j=0;j<8;j++)
                            {
                                if(hz24[k].Msk[i*3]&(0x80>>j))
                                Gui_DrawPoint(x+j,y+i,fc);
                                else
                                {
                                    if (fc!=bc) Gui_DrawPoint(x+j,y+i,bc);
                                }
                            }
                        for(j=0;j<8;j++)
                            {
                                if(hz24[k].Msk[i*3+1]&(0x80>>j))    Gui_DrawPoint(x+j+8,y+i,fc);
                                else {
                                    if (fc!=bc) Gui_DrawPoint(x+j+8,y+i,bc);
                                }
                            }
                        for(j=0;j<8;j++)
                            {
                                if(hz24[k].Msk[i*3+2]&(0x80>>j))
                                Gui_DrawPoint(x+j+16,y+i,fc);
                                else
                                {
                                    if (fc!=bc) Gui_DrawPoint(x+j+16,y+i,bc);
                                }
                            }
                    }
              }
            }
            s+=2;x+=24;
        }
    }
}
void Gui_DrawFont_Num32(u16 x, u16 y, u16 fc, u16 bc, u16 num)
{
    unsigned char i,j,k,c;
    for(i=0;i<32;i++)
    {
        for(j=0;j<4;j++)
        {
            c=*(sz32+num*32*4+i*4+j);
            for (k=0;k<8;k++)
            {

                if(c&(0x80>>k)) Gui_DrawPoint(x+j*8+k,y+i,fc);
                else {
                    if (fc!=bc) Gui_DrawPoint(x+j*8+k,y+i,bc);
                }
            }
        }
    }
}

void Gui_ShowPicture(u16 x,u16 y,u16 length,u16 width,const u8 pic[])
{
    u16 i,j;
    u32 k=0;
    Lcd_SetRegion(x,y,x+length,y+width);
#if(SPI_MODE==Hard_SPI)
     for(i=0;i<length;i++)
    {
    for(j=0;j<width;j++)
    {
        lcd_buffer[2*j+1]=pic[k];
        lcd_buffer[2*j]=pic[k+1];
        k+=2;
    }
    SPI_Write_Part_BUFFER();
    }
#elif (SPI_MODE==Soft_SPI)
    for(i=0;i<yend;i++)
          for(j=0;j<2*xend;j++)
          {
              LCD_WriteData_16Bit(color);
          }
#endif
}

