/*
 * LCD.c
 *
 *  Created on: 2023年6月9日
 *      Author: Liminnan
 */
#include <debug.h>
#include <LCD.h>
#include <spi.h>
extern uint8_t lcd_buffer[BUFFER_SIZE]; // 存储要传输到LCD屏幕的数据

//液晶IO初始化配置
void LCD_GPIO_Init(void)
{

    GPIO_InitTypeDef  GPIO_InitStructure;
#if (SPI_MODE==Soft_SPI)


    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB ,ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8| GPIO_Pin_9| GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

#if PWM_BK
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

	TIM_OCInitTypeDef TIM_OCInitStructure={0};
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE); // 使能TIM4时钟

    TIM_TimeBaseInitStructure.TIM_Prescaler = SystemCoreClock / 144000 - 1; // 设置预分频器，将系统时钟分频为1MHz
    TIM_TimeBaseInitStructure.TIM_Period = 255; // 设置计数器的周期，决定PWM的分辨率
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM4, &TIM_TimeBaseInitStructure);

    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1; // 设置PWM模式为1
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
    TIM_OCInitStructure.TIM_Pulse = 255; // 初始占空比为0，背光关闭
    TIM_OC4Init(TIM4, &TIM_OCInitStructure);

    TIM_Cmd(TIM4, ENABLE); // 使能TIM4
    TIM_SetCompare4(TIM4, 128);

#endif

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA ,ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6| GPIO_Pin_7| GPIO_Pin_8;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    //LCD_VCC GPIO_Pin_9
    //LCD_GND GPIO_Pin_10
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9|GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_SetBits(GPIOA, GPIO_Pin_9);
    GPIO_ResetBits(GPIOA, GPIO_Pin_10);




#elif (SPI_MODE==Hard_SPI)

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB ,ENABLE);
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA ,ENABLE);
    GPIO_InitStructure.GPIO_Pin =  LCD_RS;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);


    GPIO_InitStructure.GPIO_Pin = LCD_RST;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);



#if PWM_BK
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    TIM_OCInitTypeDef TIM_OCInitStructure={0};
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE); // 使能TIM4时钟

    TIM_TimeBaseInitStructure.TIM_Prescaler = SystemCoreClock / 144000 - 1; // 设置预分频器，将系统时钟分频为1MHz
    TIM_TimeBaseInitStructure.TIM_Period = 255; // 设置计数器的周期，决定PWM的分辨率
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM4, &TIM_TimeBaseInitStructure);

    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1; // 设置PWM模式为1
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
    TIM_OCInitStructure.TIM_Pulse = 255; // 初始占空比为0，背光关闭
    TIM_OC4Init(TIM4, &TIM_OCInitStructure);

    TIM_Cmd(TIM4, ENABLE); // 使能TIM4
    TIM_SetCompare4(TIM4, 255);

#elif
    GPIO_InitStructure.GPIO_Pin =  LCD_LED;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_WriteBit(GPIOB, GPIO_Pin_9, SET);
#endif

#endif
}
void LCD_SetBrightness(uint8_t Brightness){
    TIM_SetCompare4(TIM4, Brightness*255/100);
}
#if (SPI_MODE==Soft_SPI)
//向SPI总线传输一个8位数据
void  SPI_WriteData(u8 Data)
{
    unsigned char i=0;
    for(i=8;i>0;i--)
    {
            if(Data&0x80)
            LCD_SDA_SET; //输出数据
            else LCD_SDA_CLR;

      LCD_SCL_CLR;
      LCD_SCL_SET;
      Data<<=1;
    }
}
#endif

//向液晶屏写一个8位指令
void Lcd_WriteIndex(u8 Index)
{

   //SPI 写命令时序开始
   LCD_CS_CLR;
   LCD_RS_CLR;
   SPI_WriteData(Index);
   LCD_CS_SET;
}

//向液晶屏写一个8位数据
void Lcd_WriteData(u8 Data)
{
   LCD_CS_CLR;
   LCD_RS_SET;
   SPI_WriteData(Data);
   LCD_CS_SET;
}
//向液晶屏写一个16位数据
void LCD_WriteData_16Bit(u16 Data)
{
   LCD_CS_CLR;
   LCD_RS_SET;
#if (SPI_MODE==Soft_SPI)
   Lcd_WriteData(Data>>8);    //写入高8位数据
   Lcd_WriteData(Data);       //写入低8位数据
#elif (SPI_MODE==Hard_SPI)
   SPI_WriteData_16Bit(Data);
#endif
   LCD_CS_SET;
}


void Lcd_WriteReg(u8 Index,u8 Data)
{
    Lcd_WriteIndex(Index);
    Lcd_WriteData(Data);
}
void Lcd_Reset(void)
{
    LCD_RST_CLR;
    delay_us(100);
    LCD_RST_SET;
    delay_us(100);
}
void Lcd_Init() {
    LCD_GPIO_Init();
#if(SPI_MODE==Hard_SPI)
    SPI1_TX_Init();
    DMA_Tx_Init(USE_Channal,(u32)USE_TXREG,(u32)lcd_buffer,BUFFER_SIZE);
#endif
    lcd_config();
}
void lcd_config(void)
{
    Lcd_Reset(); //Reset before LCD Init.

    //LCD Init For 1.44Inch LCD Panel with ST7735R.
    Lcd_WriteIndex(0x11);//Sleep exit
    delay_ms (240);

//************* Start Initial Sequence **********//
    Lcd_WriteIndex(0x36);
    Lcd_WriteData(0x00);          //normal mode

    Lcd_WriteIndex(0x3A);
    Lcd_WriteData(0x05);                  //565,65k

    Lcd_WriteIndex(0xB1);                 //FR SET
    Lcd_WriteData(0x05);
    Lcd_WriteData(0x3C);
    Lcd_WriteData(0x3C);

    Lcd_WriteIndex(0xB2);
    Lcd_WriteData(0x05);
    Lcd_WriteData(0x3C);
    Lcd_WriteData(0x3C);

    Lcd_WriteIndex(0xB3);
    Lcd_WriteData(0x05);
    Lcd_WriteData(0x3C);
    Lcd_WriteData(0x3C);
    Lcd_WriteData(0x05);
    Lcd_WriteData(0x3C);
    Lcd_WriteData(0x3C);

    Lcd_WriteIndex(0xB4); //Column inversion
    Lcd_WriteData(0x03);

    //ST7735R Power Sequence
    Lcd_WriteIndex(0xC0);
    Lcd_WriteData(0x2E);
    Lcd_WriteData(0x06);
    Lcd_WriteData(0x04);

    Lcd_WriteIndex(0xC1);
    Lcd_WriteData(0xC0);
    Lcd_WriteData(0xC2);

    Lcd_WriteIndex(0xC2);
    Lcd_WriteData(0x0D);
    Lcd_WriteData(0x0D);

    Lcd_WriteIndex(0xC3);
    Lcd_WriteData(0x8D);
    Lcd_WriteData(0xEE);

    Lcd_WriteIndex(0xC4);
    Lcd_WriteData(0x8D);
    Lcd_WriteData(0xEE);

    Lcd_WriteIndex(0xC5); //VCOM
    Lcd_WriteData(0x00);

    Lcd_WriteIndex(0x36); //MX, MY, RGB mode
    Lcd_WriteData(0xC0);

    //ST7735R Gamma Sequence
    Lcd_WriteIndex(0xe0);
    Lcd_WriteData(0x1B);
    Lcd_WriteData(0x21);
    Lcd_WriteData(0x10);
    Lcd_WriteData(0x15);
    Lcd_WriteData(0x2B);
    Lcd_WriteData(0x25);
    Lcd_WriteData(0x1F);
    Lcd_WriteData(0x23);
    Lcd_WriteData(0x22);
    Lcd_WriteData(0x22);
    Lcd_WriteData(0x2B);
    Lcd_WriteData(0x37);
    Lcd_WriteData(0x00);
    Lcd_WriteData(0x15);
    Lcd_WriteData(0x02);
    Lcd_WriteData(0x3F);


    Lcd_WriteIndex(0xE1);
    Lcd_WriteData(0x1A);
    Lcd_WriteData(0x20);
    Lcd_WriteData(0x0F);
    Lcd_WriteData(0x15);
    Lcd_WriteData(0x2A);
    Lcd_WriteData(0x25);
    Lcd_WriteData(0x1E);
    Lcd_WriteData(0x23);
    Lcd_WriteData(0x23);
    Lcd_WriteData(0x22);
    Lcd_WriteData(0x2B);
    Lcd_WriteData(0x37);
    Lcd_WriteData(0x00);
    Lcd_WriteData(0x15);
    Lcd_WriteData(0x02);
    Lcd_WriteData(0x3F);
    Lcd_WriteIndex(0x2C); //WRITE ram
    Lcd_WriteIndex(0x29);//Display on
    //Lcd_Clear(WHITE);
}
/*************************************************
函数名：LCD_Set_Region
功能：设置lcd显示区域，在此区域写点数据自动换行
入口参数：xy起点和终点
返回值：无
*************************************************/
void Lcd_SetRegion(u16 x_start,u16 y_start,u16 x_end,u16 y_end)
{

    Lcd_WriteIndex(0x2a);
    Lcd_WriteData(0x00);
    Lcd_WriteData(x_start);//Lcd_WriteData(x_start+2);
    Lcd_WriteData(0x00);
    Lcd_WriteData(x_end+2);

    Lcd_WriteIndex(0x2b);
    Lcd_WriteData(0x00);
    Lcd_WriteData(y_start+0);
    Lcd_WriteData(0x00);
    Lcd_WriteData(y_end+1);

    Lcd_WriteIndex(0x2c);
}

/*************************************************
函数名：LCD_Set_XY
功能：设置lcd显示起始点
入口参数：xy坐标
返回值：无
*************************************************/
void Lcd_SetXY(u16 x,u16 y)
{
    Lcd_SetRegion(x,y,x,y);
}


/*************************************************
函数名：LCD_DrawPoint
功能：画一个点
入口参数：无
返回值：无
*************************************************/
void Gui_DrawPoint(u16 x,u16 y,u16 Data)
{
    Lcd_SetRegion(x,y,x+1,y+1);
    LCD_WriteData_16Bit(Data);

}
/*************************************************
函数名：Lcd_Clear
功能：全屏清屏函数
入口参数：填充颜色COLOR
返回值：无
*************************************************/
void Lcd_Clear(u16 Color)
{
   Lcd_SetRegion(0,0,X_MAX_PIXEL,Y_MAX_PIXEL);

#if (SPI_MODE==Soft_SPI)
   u8 i,m=0;
   for(i=0;i<X_MAX_PIXEL;i++)
         for(m=0;m<Y_MAX_PIXEL;m++)
         {
             LCD_WriteData_16Bit(Color);
         }
#elif (SPI_MODE==Hard_SPI)
   SPI_Write_Hole_BUFFER(Color);
#endif

   LCD_CS_SET;
}
/*
 *函数名：Lcd_Clear
 *功能：部分填充函数
 *入口参数：填充颜色color
 *返回值：无
 ************************
 * (0,0)                *
 *                      *
 *                      *
 *        (xsta,ysta)   *
 *                      *
 *                      *
 *           (xend,yend)*
 *           (128 ,160) *
 * **********************/
void Lcd_Fill(u16 xsta,u16 ysta,u16 xend,u16 yend,u16 color)
{
    u16 i,j;
    Lcd_SetRegion(xsta,ysta,xsta+xend,ysta+yend);//设置显示范围
#if(SPI_MODE==Hard_SPI)
    for(i=0;i<2*xend;i++)
    {
      lcd_buffer[2*i] = color>>8;
      lcd_buffer[2*i+1] = color;
    }
    for(j=0;j<yend;j++)
    {
        SPI_Write_Part_BUFFER();
    }
#elif (SPI_MODE==Soft_SPI)
    for(i=0;i<yend;i++)
          for(j=0;j<2*xend;j++)
          {
              LCD_WriteData_16Bit(color);
          }
#endif
}
