/*
 * spi.c
 *
 *  Created on: 2023年6月9日
 *      Author: Liminnan
 */
/*************************** 头文件 ***************************************/
#include "debug.h"
#include "string.h"
#include <spi.h>
#include <LCD.h>
/*************************** 宏定义 ***************************************/

/************************** 函数声明 **************************************/

/************************** 变量定义 **************************************/


/**************************************************************************************
 *  函 数 名: SPI_DMA_Init
 *  功能说明:Configuring the SPI for full-duplex communication.
 *  形    参: 无
 *  返 回 值: 无
 *************************************************************************************/
uint8_t lcd_buffer[BUFFER_SIZE]={0}; // 存储要传输到LCD屏幕的数据
/*DMA1Channal3*/
void SPI1_TX_Init(void)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
    //CS
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    //GPIOA 4NSS,5SCLK,6MISO,7MOSI
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    SPI_InitTypeDef SPI_InitStructure;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_Direction = SPI_Direction_1Line_Tx;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI1, &SPI_InitStructure);

    SPI_Cmd(SPI1, ENABLE);
}

/*DMA1Channal5*/
void SPI2_TX_Init(void)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
    //CS
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    //GPIOB 12NSS,13SCLK,14MISO,15MOSI
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_15;

    GPIO_Init(GPIOB, &GPIO_InitStructure);

    SPI_InitTypeDef SPI_InitStructure;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_Direction = SPI_Direction_1Line_Tx;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI2, &SPI_InitStructure);

    SPI_Cmd(SPI2, ENABLE);
}

/*DMA2Channal2*/
void SPI3_TX_Init(void)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE);
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_AFIO,ENABLE);
    GPIO_PinRemapConfig(GPIO_Remap_SPI3, ENABLE);
    //CS
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    //GPIOB 12NSS,3SCLK,4MISO,5MOSI
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10 | GPIO_Pin_12;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    SPI_InitTypeDef SPI_InitStructure;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_Direction = SPI_Direction_1Line_Tx;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI3, &SPI_InitStructure);

    SPI_Cmd(SPI3, ENABLE);
}
void DMA_Tx_Init( DMA_Channel_TypeDef* DMA_CHx, u32 ppadr, u32 memadr, u16 bufsize)
{
    DMA_InitTypeDef DMA_InitStructure={0};

    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE );
    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA2, ENABLE );
    DMA_DeInit(DMA_CHx);

    DMA_InitStructure.DMA_PeripheralBaseAddr = ppadr;
    DMA_InitStructure.DMA_MemoryBaseAddr = memadr;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;
    DMA_InitStructure.DMA_BufferSize = bufsize;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
    DMA_InitStructure.DMA_Priority = DMA_Priority_High;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init( DMA_CHx, &DMA_InitStructure );

}
//使能dma1的通道3，因为spi1TX输出对应的是此通道,5spi2TX
void dma_chanel_choose(DMA_Channel_TypeDef* dma_chanel, u32 buf_size) {
    DMA_Cmd(dma_chanel, DISABLE);                   //禁止 DMA 通道
    DMA_SetCurrDataCounter(dma_chanel, buf_size);   //设置 DMA 通道与 DMA 缓冲区大小
    DMA_Cmd(dma_chanel, ENABLE);                    //使能 DMA 通道
}
void dma_to_spix(SPI_TypeDef *spix,DMA_Channel_TypeDef* dma_chanel, u32 buf_size, uint32_t dma_flag) {
    //设置一个超时变量
    u16 timeout = 0;

    //使能 DMA
    spix->CTLR2=1 << 1; //允许DMA往缓冲区内发送
    //重新初始化DMA缓冲区大小并使能 DMA 通道
    dma_chanel_choose(dma_chanel, buf_size);

    //判断 DMA 是否完成数据传输，若超过一定时限，则中断本次传输
    while(DMA_GetFlagStatus(dma_flag) == RESET) {
        if(timeout ++ > 250) break;
    }
    // 清除 DMA 标志位
    DMA_ClearFlag(dma_flag);
    timeout = 0;
}
#if (SPI_MODE==Hard_SPI)
void SPI_WriteData(u8 Data){
   lcd_buffer[0]=Data;
   dma_to_spix(USE_SPI,USE_Channal,1,USE_TXFLAG);
}
void SPI_WriteData_16Bit(u16 Data){
    lcd_buffer[0]=Data>>8;
    lcd_buffer[1]=Data;
    dma_to_spix(USE_SPI,USE_Channal,2,USE_TXFLAG);
}
void SPI_Write_Hole_BUFFER(u16 Data){
    u16 i,j;
    for(i=0;i<2*Y_MAX_PIXEL;)    //缓存1行数据，一个像素点发两字节
         {
          lcd_buffer[i] = Data>>8; //高位数据
          lcd_buffer[i+1] = Data;  //低位数据
          i += 2; //下一个字节
         }
    for (j=0;j<X_MAX_PIXEL;j++) //有多少列写多少次，每次写一行相同的数据
         {
         LCD_CS_CLR;
         LCD_RS_SET;
         dma_to_spix(USE_SPI,USE_Channal,BUFFER_SIZE,USE_TXFLAG);
         }
}

void SPI_Write_Part_BUFFER(void){
    LCD_CS_CLR;
    LCD_RS_SET;
    dma_to_spix(USE_SPI,USE_Channal,BUFFER_SIZE,USE_TXFLAG);
    LCD_CS_SET;
}
#endif
