/*
 * spi.c
 *
 *  Created on: 202369
 *      Author: Liminnan
 */

#ifndef BSP_SPI_C_
#define BSP_SPI_C_
#include "ch32v30x.h"
#include "stdarg.h"
/*************************** 궨 ***************************************/
/**/
#define spi1 1
#define spi2 2
#define spi3 3

#define USE_spi     spi3
#define USE_spi1    (USE_spi  == spi1)
#define USE_spi2    (USE_spi  == spi2)
#define USE_spi3    (USE_spi  == spi3)


#if USE_spi1
    #define USE_SPI         SPI1
    #define USE_TXREG       &SPI1->DATAR
    #define USE_Channal     DMA1_Channel3
    #define USE_TXFLAG      DMA1_FLAG_TC3
#elif USE_spi2
    #define USE_SPI         SPI2
    #define USE_TXREG       &SPI2->DATAR
    #define USE_Channal     DMA1_Channel5
    #define USE_TXFLAG      DMA1_FLAG_TC5
#elif USE_spi3
    #define USE_SPI         SPI3
    #define USE_TXREG       &SPI3->DATAR
    #define USE_Channal     DMA2_Channel2
    #define USE_TXFLAG      DMA2_FLAG_TC2
#endif


#define Soft_SPI 0
#define Hard_SPI 1
#define SPI_MODE Hard_SPI
/**************************  **************************************/
/* ⲿõĺ */

void SPI1_TX_Init(void);
void SPI2_TX_Init(void);
void SPI_WriteData(u8 Data);
void SPI_WriteData_16Bit(u16 Data);
void SPI_Write_Hole_BUFFER(u16 Data);
void SPI_Write_Part_BUFFER(void);
void dma_chanel_choose(DMA_Channel_TypeDef* dma_chanel, u32 buf_size);
void dma_to_spix(SPI_TypeDef *spix,DMA_Channel_TypeDef* dma_chanel, u32 buf_size, uint32_t dma_flag);
void DMA_Tx_Init( DMA_Channel_TypeDef* DMA_CHx, u32 ppadr, u32 memadr, u16 bufsize);

#endif /* BSP_SPI_C_ */
